/* Copyright (C) 2002, by Sandor Fazekas and Janos Torok */
/* Last modified: $Date: 2004/04/23 17:20:43 $ $Revision: 1.3 $ */
#include <stdlib.h>
#include <math.h>
#include <gtk/gtk.h>
#include "global.h"

/* Prototypes */
int ilog(double);
gint AnimateBody(gpointer);
void Write_rc(void);
void Write_Constraint(int);

gint Quit(GtkWidget *widget)
{
    gtk_signal_disconnect_by_func(GTK_OBJECT(ctrlwin),
				GTK_SIGNAL_FUNC (Quit), NULL);
    gtk_signal_disconnect_by_func(GTK_OBJECT(glwin),
				GTK_SIGNAL_FUNC (Quit), NULL);
    gtk_widget_destroy(ctrlwin);
    gtk_widget_destroy(glwin);
  if (anim.writerc) Write_rc();
  else Write_Constraint(0);
  gtk_main_quit();

  exit(0);
}

gint AnimframeSlider_Changed(GtkWidget *widget, GtkWidget *animframevalue)
{
  int l;
  char *s;

  l=ilog(GTK_ADJUSTMENT(widget)->value);
  s=(char *) calloc(l+1,sizeof(char));
  sprintf(s,"%d",(int)(GTK_ADJUSTMENT(widget)->value));
  gtk_entry_set_text(GTK_ENTRY(animframevalue),s);
  free(s);
  anim.framedt=(int)(GTK_ADJUSTMENT(widget)->value);
  if (anim.timeouttag) {
    anim.imeasuredt=0;
    gtk_timeout_remove(anim.timeouttag);
    anim.timeouttag=gtk_timeout_add(anim.framedt,AnimateBody,
		GTK_OBJECT(gl.glarea));
  }

  return(1);
}

gint AnimframeValue_Changed(GtkWidget *widget, GtkObject *animframeslideradj)
{
  int v,animframe_text;

  v=atoi(gtk_entry_get_text(GTK_ENTRY(widget)));
  animframe_text=0;
  if (v<GTK_ADJUSTMENT(animframeslideradj)->lower) {
    v=(int)GTK_ADJUSTMENT(animframeslideradj)->lower;
    animframe_text=1;
  }
  if (v>GTK_ADJUSTMENT(animframeslideradj)->upper) {
    v=(int)GTK_ADJUSTMENT(animframeslideradj)->upper;
    animframe_text=1;
  }
  GTK_ADJUSTMENT(animframeslideradj)->value=v;
  gtk_signal_emit_by_name (GTK_OBJECT (animframeslideradj), "value_changed");
  return(1);
}

void Toggle_Adjustanimframe(GtkToggleButton *button)
{
  anim.adjustframedt=button->active;
  anim.imeasuredt=0;
}

/* EOF */
